//
//  OpenGL Ex12opengl Widget
//

#ifndef EX12OPENGL_H
#define EX12OPENGL_H

#include <QtOpenGL>
#include <QString>
#include <QVector>
#include <QImage>
#include "Object.h"

class Ex12opengl : public QGLWidget
{
Q_OBJECT
private:
   bool    init;         //  Initialized
   int     N;            //  Number of passes
   float   x0,y0;        //  Image center
   float   zoom;         //  Zoom
   int     w,h;          //  Image size
   int     mode;         //  Display mode
   bool    mouse;        //  Mouse pressed
   QPoint  pos;          //  Mouse position
   unsigned int frame;                //  Image frame
   QGLFramebufferObject* framebuf[2]; //  Framebuffers
   QGLShaderProgram shader[9];        //  Shaders
public:
   Ex12opengl(QWidget* parent=0);                  //  Constructor
   QSize sizeHint() const {return QSize(400,400);} //  Default size of widget
public slots:
    void setPasses(int pass);              //  Slot to set number of passes
    void setShader(int sel);               //  Slot to set shader
    void setImage(QImage img);             //  Slot to set image
    void reset();                          //  Reset view
protected:
    void initializeGL();                   //  Initialize widget
    void resizeGL(int width, int height);  //  Resize widget
    void paintGL();                        //  Draw widget
    void mousePressEvent(QMouseEvent*);    //  Mouse pressed
    void mouseReleaseEvent(QMouseEvent*);  //  Mouse released
    void mouseMoveEvent(QMouseEvent*);     //  Mouse moved
    void wheelEvent(QWheelEvent*);         //  Mouse wheel
private:
   void Fatal(QString message);            //  Error handler
   void Shader(QGLShaderProgram& shader,QString vert,QString frag);  //  Create shader
};

#endif
